#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>



int main(int argc, char **argv)
{
  char filename[256], cpuid[256], *file;
  int pwid=-1;
  FILE *in;
  struct stat stbuf;
  int len=0;

  if (argc < 2 || (strlen(argv[1]) > 255))
    return 1;

  strcpy(filename, "/proc/pn_cpu_id");
  if((in = fopen(filename, "r")) == NULL)
    return -1;

  if (fscanf(in, "Unique ID: %s", cpuid) != 1)
    return -2;
  fclose(in);

  strcpy(filename, argv[1]);
  file = (char *)strrchr(filename, '/');
  if ((file-filename) > 244)
    return 2;
  strcpy(file, "/plugin.ini");
  if (stat(filename, &stbuf) != 0)
    return 3;

  if((in = fopen(filename, "r")) == NULL)
    return -3;

  while(fscanf(in, " id = %d", &pwid) != 1) {
    if (fscanf(in, " %*s") == EOF)
      break;
  }
  fclose(in);

  printf("Unique ID: %s\nPWid: %d\n", cpuid, pwid);
  return 0;

}
